<?php
/***************************************************************************
*                            Dolphin Smart Community Builder
*                              -------------------
*     begin                : Mon Mar 23 2006
*     copyright            : (C) 2007 BoonEx Group
*     website              : http://www.boonex.com
* This file is part of Dolphin - Smart Community Builder
*
* Dolphin is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the
* License, or  any later version.
*
* Dolphin is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
* without even the implied warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License for more details.
* You should have received a copy of the GNU General Public License along with Dolphin,
* see license.txt file; if not, write to marketing@boonex.com
***************************************************************************/

bx_import('BxDolViews');
bx_import('BxDolAlerts');
bx_import('BxDolModule');
bx_import('BxDolPaginate');
bx_import('BxDolCategories');
bx_import('BxDolRssFactory');
bx_import('BxDolSubscription');
bx_import('BxDolAdminSettings');

class BxDolTextModule extends BxDolModule {
	var $_oTextData;

	function BxDolTextModule($aModule) {
		parent::BxDolModule($aModule);

		$this->_oConfig->init($this->_oDb);
	    $this->_oTemplate->init($this->_oDb);

	    $sClassName = $this->_oConfig->getClassPrefix() . 'TextData';
	    $this->_oTextData = new $sClassName($this);
	}
	
	function getCalendar($iYear = 0, $iMonth = 0) {
		$sClassName = $this->_oConfig->getClassPrefix() . 'Calendar';
	    return new $sClassName($iYear, $iMonth, $this->_oDb, $this->_oConfig);
	}

	function getSearchResult() {
		$sClassName = $this->_oConfig->getClassPrefix() . 'SearchResult';
	    return new $sClassName($this);
	}

	function getSearchContent($aRestrictions, $sUri, $iPage = 1, $iPerPage = 0) {
		$iPerPage = !empty($iPerPage) ? $iPerPage : $this->_oConfig->getPerPage();
 
		$sClassName = $this->_oConfig->getClassPrefix() . 'SearchResult';
	    $oSearchResult = new $sClassName($this);		    
	    foreach($aRestrictions as $sKey => $mixedValue)
	    	if(is_array($mixedValue))
	    		$oSearchResult->aCurrent['restriction'][$sKey] = $mixedValue;
	    	else if(is_string($mixedValue))
	    		$oSearchResult->aCurrent['restriction'][$sKey]['value'] = $mixedValue;
	    $oSearchResult->aCurrent['paginate']['forcePage'] = $iPage;
	    $oSearchResult->aCurrent['paginate']['perPage'] = $iPerPage;
	    $sCode = $oSearchResult->displayResultBlock();

	    if(!empty($sCode)) {
	        $oPaginate = new BxDolPaginate(array(
	            'page_url' => BX_DOL_URL_ROOT . $this->_oConfig->getBaseUri() . $sUri . '{page}/{per_page}',
	            'count' => $oSearchResult->aCurrent['paginate']['totalNum'],
	            'per_page' => $iPerPage,
	            'page' => $iPage,
	            'per_page_changer' => true,
	            'page_reloader' => false,
	            'on_change_page' => '',
	            'on_change_per_page' => '',
	        ));
	        $sCode .= $oPaginate->getPaginate();
	    }

	    return $sCode;
	}
	function getCategoryContent(&$aRequest, &$sContent) {
		$sCategory = uri2title(process_db_input(array_shift($aRequest), BX_TAGS_STRIP));
		$sCategoryDisplay = $GLOBALS['MySQL']->unescape($sCategory);
		$iPage = !empty($aRequest) && !empty($aRequest[0]) ? (int)array_shift($aRequest) : 1;
		$iPerPage = !empty($aRequest) && !empty($aRequest[0]) ? (int)array_shift($aRequest) : 0;

	    $sContent = $this->getSearchContent(array('category' => $sCategory), 'category/' . title2uri($sCategoryDisplay) . '/', $iPage, $iPerPage);
	    return $sCategoryDisplay;
	}
	function getTagContent(&$aRequest, &$sContent) {
		$sTag = uri2title(process_db_input(array_shift($aRequest), BX_TAGS_STRIP));
		$sTagDisplay = $GLOBALS['MySQL']->unescape($sTag);
		$iPage = !empty($aRequest) && !empty($aRequest[0]) ? (int)array_shift($aRequest) : 1;
		$iPerPage = !empty($aRequest) && !empty($aRequest[0]) ? (int)array_shift($aRequest) : 0;

	    $sContent = $this->getSearchContent(array('tag' => $sTag), 'tag/' . title2uri($sTagDisplay) . '/', $iPage, $iPerPage);
	    return $sTagDisplay;
	}
	function getCalendarContent(&$aRequest, &$sContent) {
		$iYear = (int)array_shift($aRequest);
	    $iMonth = (int)array_shift($aRequest);
	    $iDay = (int)array_shift($aRequest);
	    $iPage = !empty($aRequest) && !empty($aRequest[0]) ? (int)array_shift($aRequest) : 1;
		$iPerPage = !empty($aRequest) && !empty($aRequest[0]) ? (int)array_shift($aRequest) : 0;

		$sContent = $this->getSearchContent(
			array(
				'calendar-min' => array('value' => "UNIX_TIMESTAMP('" . $iYear . "-" . $iMonth . "-" . $iDay . " 00:00:00')", 'field' => 'when', 'operator' => '>=', 'no_quote_value' => true),
				'calendar-max' => array('value' => "UNIX_TIMESTAMP('" . $iYear . "-" . $iMonth . "-" . $iDay . " 23:59:59')", 'field' => 'when', 'operator' => '<=', 'no_quote_value' => true),
			), 
			'calendar/' . $iYear . '/' . $iMonth . '/' . $iDay . '/', 
			$iPage, 
			$iPerPage
		);
	}

	/**
	 * Admin Settings Methods
	 */
	function getSettingsForm($mixedResult) {
		$sUri = $this->_oConfig->getUri();

	    $iId = (int)$this->_oDb->getOne("SELECT `ID` FROM `sys_options_cats` WHERE `name`='" . ucwords(str_replace('_', ' ', $sUri)) . "'");
	    if(empty($iId))
			return MsgBox('_' . $sUri . '_msg_no_results');

        $oSettings = new BxDolAdminSettings($iId, BX_DOL_URL_ROOT . $this->_oConfig->getBaseUri() . 'admin');
        $sResult = $oSettings->getForm();

        if($mixedResult !== true && !empty($mixedResult))
            $sResult = $mixedResult . $sResult;

        return $sResult;
	}
	function setSettings($aData) {
		$sUri = $this->_oConfig->getUri();

	    $iId = (int)$this->_oDb->getOne("SELECT `ID` FROM `sys_options_cats` WHERE `name`='" . ucwords(str_replace('_', ' ', $sUri)) . "'");
	    if(empty($iId))
	       return MsgBox(_t('_' . $sUri . '_msg_no_results'));

	    $oSettings = new BxDolAdminSettings($iId);
	    return $oSettings->saveChanges($_POST);
	}
}
?>