<?
/***************************************************************************
*                            Dolphin Smart Community Builder
*                              -------------------
*     begin                : Mon Mar 23 2006
*     copyright            : (C) 2007 BoonEx Group
*     website              : http://www.boonex.com
* This file is part of Dolphin - Smart Community Builder
*
* Dolphin is free software; you can redistribute it and/or modify it under
* the terms of the GNU General Public License as published by the
* Free Software Foundation; either version 2 of the
* License, or  any later version.
*
* Dolphin is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY;
* without even the implied warranty of  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
* See the GNU General Public License for more details.
* You should have received a copy of the GNU General Public License along with Dolphin,
* see license.txt file; if not, write to marketing@boonex.com
***************************************************************************/

bx_import('BxDolTextModule');

require_once('BxArlCalendar.php');
require_once('BxArlCmts.php');
require_once('BxArlVoting.php');
require_once('BxArlSearchResult.php');
require_once('BxArlTextData.php');

/*
 * Articles module by BoonEx
 *
 * This module is needed to manage site articles.
 *
 *
 * Profile's Wall:
 * no spy events
 *
 *
 *
 * Spy:
 * no spy events
 *
 *
 *
 * Memberships/ACL:
 * Doesn't depend on user's membership.
 *
 * 
 *
 * Service methods:
 *
 * Get post block. 
 * @see BxArlModule::servicePostBlock
 * BxDolService::call('articles', 'post_block');
 * @note is needed for internal usage.
 *
 * Get edit block.
 * @see BxArlModule::serviceEditBlock
 * BxDolService::call('articles', 'edit_block', array($mixed));
 * @note is needed for internal usage.
 *
 * Get administration block.
 * @see BxArlModule::serviceAdminBlock
 * BxDolService::call('articles', 'admin_block', array($iStart, $iPerPage, $sFilterValue));
 * @note is needed for internal usage.
 *
 * Get block with all articles ordered by the time of posting.
 * @see BxArlModule::serviceArchiveBlock
 * BxDolService::call('articles', 'archive_block', array($iStart, $iPerPage));
 * @note is needed for internal usage.
 *
 * Get block with articles marked as featured.
 * @see BxArlModule::serviceFeaturedBlock
 * BxDolService::call('articles', 'featured_block', array($iStart, $iPerPage));
 * @note is needed for internal usage.
 *
 * Get block with articles ordered by their rating.
 * @see BxArlModule::serviceTopRatedBlock
 * BxDolService::call('articles', 'top_rated_block', array($iStart, $iPerPage));
 * @note is needed for internal usage.
 *
 * Get block with all articles ordered by their popularity(number of views).
 * @see BxArlModule::servicePopularBlock
 * BxDolService::call('articles', 'popular_block', array($iStart, $iPerPage));
 * @note is needed for internal usage.
 * 
 * Get the block with article content for view article page.
 * @see BxArlModule::serviceViewBlock
 * BxDolService::call('articles', 'view_block', array($sUri));
 * @note is needed for internal usage.
 *
 * Get the block with article comments for view article page.
 * @see BxArlModule::serviceCommentBlock
 * BxDolService::call('articles', 'comment_block', array($sUri));
 * @note is needed for internal usage.
 
 * Get the block with article votes for view article page.
 * @see BxArlModule::serviceVoteBlock
 * BxDolService::call('articles', 'vote_block', array($sUri));
 * @note is needed for internal usage.
 *
 * Get the block with article actions for view article page.
 * @see BxArlModule::serviceActionBlock
 * BxDolService::call('articles', 'action_block', array($sUri));
 * @note is needed for internal usage. 
 *
 *
 * Alerts:
 * Alerts type/unit - 'articles'
 * The following alerts are rised
 *
 *  post - article is added
 *      $iObjectId - article id
 *      $iSenderId - admin's id
 *
 *  edit - article was modified
 *      $iObjectId - article id
 *      $iSenderId - admin's id
 *
 *  featured - article was marked as featured
 *      $iObjectId - article id
 *      $iSenderId - admin's id
 *
 *  publish - article was published
 *      $iObjectId - article id
 *      $iSenderId - admin's id
 *
 *  unpublish - article was unpublished
 *      $iObjectId - article id
 *      $iSenderId - admin's id
 *
 *  delete - article was deleted
 *      $iObjectId - article id
 *      $iSenderId - admin's id
 *
 */
class BxArlModule extends BxDolTextModule {
	/**
	 * Constructor
	 */
	function BxArlModule($aModule) {
	    parent::BxDolTextModule($aModule);

	    //--- Define Membership Actions ---//
        defineMembershipActions(array('articles delete'), 'ACTION_ID_');
	}

	/**
	 * Service methods
	 */
	function servicePostBlock() {
	    $aVariables = array(
	       'include_css' => $this->_oTemplate->addCss(array('post.css'), true),
	       'post_form' => $this->_oTextData->getPostForm()
	    );
	    return $this->_oTemplate->parseHtmlByName('post.html', $aVariables);
	}
	function serviceEditBlock($mixed) {
	    if(is_string($mixed))
	       $aArticle = $this->_oDb->getArticles(array('sample_type' => 'uri', 'uri' => $mixed));
	    else if(is_int($mixed))
	       $aArticle = $this->_oDb->getArticles(array('sample_type' => 'id', 'id' => $mixed));

	    $aVariables = array(
	       'include_css' => $this->_oTemplate->addCss(array('post.css'), true),
	       'post_form' => $this->_oTextData->getEditForm($aArticle)
	    );
	    return $this->_oTemplate->parseHtmlByName('post.html', $aVariables);
	}
	/**
	 * Replace with a number of separate functions
	 */
	function serviceAdminBlock($iStart = 0, $iPerPage = 0, $sFilterValue = '') {
	    if(empty($iPerPage))
            $iPerPage = $this->_oConfig->getPerPage();
        
        return $this->_oTemplate->displayAdminBlock(array(
	       'sample_type' => 'admin', 
	       'viewer_type' => $this->_oTextData->getViewerType(), 
	       'start' => $iStart, 
	       'count' => $iPerPage,
	       'admin_panel' => true,
	       'filter_value' => $sFilterValue,
	       'search_result_object' => $this->getSearchResult()
        ));
	}
	function serviceArchiveBlockIndex($iStart = 0, $iPerPage = 0, $bShowEmpty = true) {
		if(empty($iPerPage))
            $iPerPage = $this->_oConfig->getIndexNumber();

		return $this->serviceArchiveBlock($iStart, $iPerPage, $bShowEmpty);
	}
	function serviceArchiveBlockMember($iStart = 0, $iPerPage = 0, $bShowEmpty = true) {
		if(empty($iPerPage))
            $iPerPage = $this->_oConfig->getMemberNumber();

		return $this->serviceArchiveBlock($iStart, $iPerPage, $bShowEmpty);
	}
	function serviceArchiveBlock($iStart = 0, $iPerPage = 0, $bShowEmpty = true) {
	    if(empty($iPerPage))
            $iPerPage = $this->_oConfig->getPerPage();

	    return $this->_oTemplate->displayBlock(array(
	       'sample_type' => 'archive', 
	       'viewer_type' => $this->_oTextData->getViewerType(), 
	       'start' => $iStart, 
	       'count' => $iPerPage,
	       'show_empty' => $bShowEmpty
        ));
	}
	function serviceFeaturedBlockIndex($iStart = 0, $iPerPage = 0, $bShowEmpty = true) {
		if(empty($iPerPage))
            $iPerPage = $this->_oConfig->getIndexNumber();

		return $this->serviceFeaturedBlock($iStart, $iPerPage, $bShowEmpty);
	}
	function serviceFeaturedBlockMember($iStart = 0, $iPerPage = 0, $bShowEmpty = true) {
		if(empty($iPerPage))
            $iPerPage = $this->_oConfig->getMemberNumber();

		return $this->serviceFeaturedBlock($iStart, $iPerPage, $bShowEmpty);
	}
	function serviceFeaturedBlock($iStart = 0, $iPerPage = 0, $bShowEmpty = true) {
	    if(empty($iPerPage))
            $iPerPage = $this->_oConfig->getPerPage();

	    return $this->_oTemplate->displayBlock(array(
	       'sample_type' => 'featured', 
	       'viewer_type' => $this->_oTextData->getViewerType(), 
	       'start' => $iStart, 
	       'count' => $iPerPage,
	       'show_empty' => $bShowEmpty
        ));
	}
	function serviceTopRatedBlock($iStart = 0, $iPerPage = 0) {
	    if(empty($iPerPage))
            $iPerPage = $this->_oConfig->getPerPage();

	    return $this->_oTemplate->displayBlock(array(
	       'sample_type' => 'top_rated', 
	       'viewer_type' => $this->_oTextData->getViewerType(), 
	       'start' => $iStart, 
	       'count' => $iPerPage
        ));
	}
	function servicePopularBlock($iStart = 0, $iPerPage = 0) {
	    if(empty($iPerPage))
            $iPerPage = $this->_oConfig->getPerPage();

	    return $this->_oTemplate->displayBlock(array(
	       'sample_type' => 'popular', 
	       'viewer_type' => $this->_oTextData->getViewerType(), 
	       'start' => $iStart, 
	       'count' => $iPerPage
        ));
	}
	
	
	
	/**
	 * View Single Article Blocks
	 */
	function serviceViewBlock($sUri) {
	    $aParams = is_numeric($sUri) ? array('sample_type' => 'id', 'id' => $sUri) : array('sample_type' => 'uri', 'uri' => $sUri);
	    $aArticle = $this->_oDb->getArticles($aParams);
	    
	    $oView = new BxDolViews('bx_' . $this->_oConfig->getUri(), $aArticle['id']);
        $oView->makeView();
        
        $this->_oTemplate->setPageTitle($aArticle['caption']);
        $GLOBALS['oTopMenu']->setCustomSubHeader($aArticle['caption']);
        $GLOBALS['oTopMenu']->setCustomBreadcrumbs(array(
            _t('_articles_top_menu_item') => BX_DOL_URL_ROOT . $this->_oConfig->getBaseUri() . 'index/',
            $aArticle['caption'] => '')
        );
	    return $this->_oTemplate->displayList(array(
	       'sample_type' => 'view', 
	       'viewer_type' => $this->_oTextData->getViewerType(), 
	       'uri' => $aArticle['uri']
        ));
	}
	function serviceCommentBlock($sUri) {
	    $aParams = is_numeric($sUri) ? array('sample_type' => 'id', 'id' => $sUri) : array('sample_type' => 'uri', 'uri' => $sUri);
	    $aArticle = $this->_oDb->getArticles($aParams);
	    if(!$this->_oConfig->isCommentsAllowed()) 
	       return '';

	    if($aArticle['status'] != BX_TD_STATUS_ACTIVE)
            return MsgBox(_t('_articles_msg_no_results'));

        $this->_oTemplate->addCss(array('cmts.css'));
        $oComments = new BxArlCmts($this->_oConfig->getCommentsSystemName(), $aArticle['id']);
	    return $oComments->getCommentsFirst('comment');
	}
	function serviceVoteBlock($sUri) {
	    $aParams = is_numeric($sUri) ? array('sample_type' => 'id', 'id' => $sUri) : array('sample_type' => 'uri', 'uri' => $sUri);
	    $aArticle = $this->_oDb->getArticles($aParams);
	    if(!$this->_oConfig->isVotesAllowed()) 
	       return '';
	       
	    if($aArticle['status'] != BX_TD_STATUS_ACTIVE)
            return MsgBox(_t('_articles_msg_no_results'));

        $oVotes = new BxArlVoting($this->_oConfig->getVotesSystemName(), $aArticle['id']);
	    return $oVotes->getBigVoting();
	}
	function serviceActionBlock($sUri) {
	    $aParams = is_numeric($sUri) ? array('sample_type' => 'id', 'id' => $sUri) : array('sample_type' => 'uri', 'uri' => $sUri);
	    $aArticle = $this->_oDb->getArticles($aParams);
	    
	    if($aArticle['status'] != BX_TD_STATUS_ACTIVE)
            return MsgBox(_t('_articles_msg_no_results'));

        $oSubscription = new BxDolSubscription();
        $aButton = $oSubscription->getButton($this->getUserId(), 'bx_' . $this->_oConfig->getUri(), '', $aArticle['id']);        

		$aReplacement['sbs_articles_title'] = $aButton['title']; 
        $aReplacement['sbs_articles_script'] = $aButton['script'];
                
        if($this->_isDeleteAllowed()) {
        	$this->_oTemplate->addJsTranslation(array('_articles_msg_success_delete', '_articles_msg_failed_delete'));
        	
        	$aReplacement['del_articles_title'] = _t('_articles_actions_delete');
        	$aReplacement['del_articles_script'] = $this->_oConfig->getJsObject() . '.deleteArticle(' . $aArticle['id'] . ')';
        }
        else
        	$aReplacement['del_articles_title'] = '';
        	
		return $oSubscription->getData() . $GLOBALS['oFunctions']->genObjectsActions($aReplacement, 'bx_' . $this->_oConfig->getUri());
	}
	function serviceGetSubscriptionParams($sUnit, $sAction, $iObjectId) {
		$sUnit = str_replace('bx_', '_', $sUnit);
		if(empty($sAction))
			$sAction = 'main';

		$aItem = $this->_oDb->getArticles(array('sample_type' => 'id', 'id' => $iObjectId));

		return array(
			'template' => array(
				'Subscription' => _t($sUnit . '_sbs_' . $sAction, $aItem['caption']), 
				'ViewLink' => BX_DOL_URL_ROOT . $this->_oConfig->getBaseUri()  . 'view/' . $aItem['uri']
			)
		);
	}

	/**
	 * Action methods
	 *
	 * Get RSS for articles.
	 *
	 * @return string with RSS.
	 */
	function actionRss() {
	    $aEntries = $this->_oDb->getArticles(array(
            'sample_type' => 'archive', 
            'viewer_type' => $this->_oTextData->getViewerType(), 
            'start' => 0, 
            'count' => (int)$this->_oConfig->getRssLength()
        ));

        $aRssData = array();
        $sRssViewUrl = BX_DOL_URL_ROOT . $this->_oConfig->getBaseUri() . 'view/';
        foreach($aEntries as $aEntry) {
            if(empty($aEntry['caption'])) continue;

        	$aRssData[$aEntry['id']] = array(
        	   'UnitID' => $aEntry['id'],
        	   'OwnerID' => $aEntry['id'],
        	   'UnitTitle' => $aEntry['caption'],
        	   'UnitLink' => $sRssViewUrl . $aEntry['uri'],
        	   'UnitDesc' => $aEntry['content'],
        	   'UnitDateTimeUTS' => $aEntry['when_uts'],
        	   'UnitIcon' => ''
            );
        }

	    $oRss = new BxDolRssFactory();
	    return $oRss->GenRssByData($aRssData, _t('_articles_rss_caption'), $this->_oConfig->getBaseUri() . 'act_rss/');
	}
	function actionGetArticles($sSampleType = 'all', $iStart = 0, $iPerPage = 0) {
	    check_logged();
	    
	    if(empty($iPerPage))
            $iPerPage = $this->_oConfig->getPerPage();

	    return $this->_oTemplate->displayList(array(
            'sample_type' => $sSampleType, 
            'viewer_type' => $this->_oTextData->getViewerType(), 
            'start' => $iStart, 
            'count' => $iPerPage,
	    	'filter_value' => isset($_POST['filter_value']) ? process_db_input($_POST['filter_value'], BX_TAGS_STRIP) : ''
        ));
	}
	function actionFeatured() {
		$iId = (int)$_POST['id'];

		return !empty($iId) ? $this->_actFeatured($iId) : false;
	}
	function actionPublish() {
		$iId = (int)$_POST['id'];

		return !empty($iId) ? $this->_actPublish($iId) : false;
	}
	function actionDelete() {
		$iId = (int)$_POST['id'];

		return !empty($iId) ? $this->_actDelete($iId) : false;
	}

	function _actFeatured($aIds, $bPositive = true) {	    
	    if(!isAdmin()) 
            return false;

		if(is_int($aIds) || is_string($aIds))
			$aIds = array((int)$aIds);

	    $bResult = $this->_oDb->updateArticles($aIds, array('featured' => ($bPositive ? 1 : 0)));
	    if($bResult)
	        foreach($aIds as $iId) {
    	        //--- Articles -> Featured for Alerts Engine ---//
                bx_import('BxDolAlerts');
                $oAlert = new BxDolAlerts('bx_' . $this->_oConfig->getUri(), 'featured', $iId, BxDolTextData::getAuthorId());
                $oAlert->alert();
                //--- Articles -> Featured for Alerts Engine ---//
	        }

	    return $bResult;
	}
	function _actPublish($aIds, $bPositive = true) {
	    if(!isAdmin()) 
            return false;

		if(is_int($aIds) || is_string($aIds))
			$aIds = array((int)$aIds);

	    $bResult = $this->_oDb->updateArticles($aIds, array('status' => ($bPositive ? BX_TD_STATUS_ACTIVE : BX_TD_STATUS_INACTIVE)));
	    if($bResult)
	        foreach($aIds as $iId) {
    	        //--- Articles -> Publish/Unpublish for Alerts Engine ---//
                $oAlert = new BxDolAlerts('bx_' . $this->_oConfig->getUri(), ($bPositive ? 'publish' : 'unpublish'), $iId, BxDolTextData::getAuthorId());
                $oAlert->alert();
                //--- Articles -> Publish/Unpublish for Alerts Engine ---//
                
                //--- Reparse Global Tags ---//
                $oTags = new BxDolTags();
                $oTags->reparseObjTags('bx_' . $this->_oConfig->getUri(), $iId);
                //--- Reparse Global Tags ---//
                
                //--- Reparse Global Categories ---//            
                $oCategories = new BxDolCategories();
                $oCategories->reparseObjTags('bx_' . $this->_oConfig->getUri(), $iId);
                //--- Reparse Global Categories ---//
	        }
        
	    return $bResult;
	}
	function _actDelete($aIds) {	    
	    if(!$this->_isDeleteAllowed(true)) 
            return false;

		if(is_int($aIds) || is_string($aIds))
			$aIds = array((int)$aIds);
	    	    
	    $bResult = $this->_oDb->deleteArticles($aIds);
	    if($bResult) {
            $oTags = new BxDolTags();
            $oCategories = new BxDolCategories();
            $oSubscription = new BxDolSubscription();

	        foreach($aIds as $iId) {
    	        //--- Articles -> Delete for Alerts Engine ---//
                $oAlert = new BxDolAlerts('bx_' . $this->_oConfig->getUri(), 'delete', $iId, BxDolTextData::getAuthorId());
                $oAlert->alert();
                //--- Articles -> Delete for Alerts Engine ---//
                
                //--- Reparse Global Tags ---//
                $oTags->reparseObjTags('bx_' . $this->_oConfig->getUri(), $iId);
                //--- Reparse Global Tags ---//
                
                //--- Reparse Global Categories ---//
                $oCategories->reparseObjTags('bx_' . $this->_oConfig->getUri(), $iId);
                //--- Reparse Global Categories ---//
                
                //--- Remove all subscriptions ---//
                $oSubscription->unsubscribe(array('type' => 'object_id', 'unit' => 'bx_' . $this->_oConfig->getUri(), 'object_id' => $iId));
                //--- Remove all subscriptions ---//
	        }
	    }
	    return $bResult;
	}
	function _isDeleteAllowed($bPerform = false) {
		if(!isLogged())
			return false;

		if(isAdmin())
			return true;
			
		$aCheckResult = checkAction(getLoggedId(), ACTION_ID_ARTICLES_DELETE, $bPerform);			
		return $aCheckResult[CHECK_ACTION_RESULT] == CHECK_ACTION_RESULT_ALLOWED;
	}
}
?>